diff --git a/src/backend/access/sequence/seqamapi.c b/src/backend/access/sequence/seqamapi.c
new file mode 100644
index 0000000..ef8e7a4
--- /dev/null
+++ b/src/backend/access/sequence/seqamapi.c
@@ -0,0 +1,191 @@
+/*-------------------------------------------------------------------------
+ *
+ * seqamapi.c
+ *	  general sequence access method routines
+ *
+ * Portions Copyright (c) 1996-2015, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/sequence/seqamapi.c
+ *
+ *
+ * Sequence access method allows the SQL Standard Sequence objects to be
+ * managed according to either the default access method or a pluggable
+ * replacement. Each sequence can only use one access method at a time,
+ * though different sequence access methods can be in use by different
+ * sequences at the same time.
+ *
+ * The SQL Standard assumes that each Sequence object is completely controlled
+ * from the current database node, preventing any form of clustering mechanisms
+ * from controlling behaviour. Sequence access methods are general purpose
+ * though designed specifically to address the needs of Sequences working as
+ * part of a multi-node "cluster", though that is not defined here, nor are
+ * there dependencies on anything outside of this module, nor any particular
+ * form of clustering.
+ *
+ * The SQL Standard behaviour, also the historical PostgreSQL behaviour, is
+ * referred to as the "Local" SeqAM. That is also the basic default.  Local
+ * SeqAM assumes that allocations from the sequence will be contiguous, so if
+ * user1 requests a range of values and is given 500-599 as values for their
+ * backend then the next user to make a request will be given a range starting
+ * with 600.
+ *
+ * The SeqAM mechanism allows us to override the Local behaviour, for use with
+ * clustering systems. When multiple masters can request ranges of values it
+ * would break the assumption of contiguous allocation. It seems likely that
+ * the SeqAM would also wish to control node-level caches for sequences to
+ * ensure good performance. The CACHE option and other options may be
+ * overridden by the _init API call, if needed, though in general having
+ * cacheing per backend and per node seems desirable.
+ *
+ * SeqAM allows calls to allocate a new range of values, reset the sequence to
+ * a new value and to define options for the AM module. The on-disk format of
+ * Sequences is the same for all AMs, except that each sequence has a SeqAm
+ * defined private-data column, amstate.
+ *
+ * SeqAMs work similarly to IndexAMs in many ways. pg_class.relam stores the
+ * Oid of the SeqAM, just as we do for IndexAm. The relcache stores AM
+ * information in much the same way for indexes and sequences, and management
+ * of options is similar also.
+ *
+ * Note that the SeqAM API calls are synchronous. It is up to the SeqAM to
+ * decide how that is handled, for example, whether there is a higher level
+ * cache at instance level to amortise network traffic in cluster.
+ *
+ * The SeqAM is identified by Oid of corresponding tuple in pg_am.
+ * -------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/reloptions.h"
+#include "access/relscan.h"
+#include "access/seqamapi.h"
+#include "access/transam.h"
+#include "access/xact.h"
+#include "catalog/pg_am.h"
+#include "catalog/pg_type.h"
+#include "utils/builtins.h"
+#include "utils/guc.h"
+#include "utils/lsyscache.h"
+#include "utils/memutils.h"
+#include "utils/rel.h"
+#include "utils/syscache.h"
+
+
+/*
+ * GetSeqAmRoutine - call the specified access method handler routine
+ * to get its SeqAmRoutine struct.
+ */
+SeqAmRoutine *
+GetSeqAmRoutine(Oid amhandler)
+{
+	Datum			datum;
+	SeqAmRoutine   *routine;
+
+	datum = OidFunctionCall0(amhandler);
+	routine = (SeqAmRoutine *) DatumGetPointer(datum);
+
+	if (routine == NULL || !IsA(routine, SeqAmRoutine))
+		elog(ERROR, "sequence access method handler function %u did not return an SeqAmRoutine struct",
+			 amhandler);
+
+	return routine;
+}
+
+/*
+ * GetSeqAmRoutineByAMId - look up the handler of the sequence access method
+ * for the given OID, and retrieve its SeqAmRoutine struct.
+ */
+SeqAmRoutine *
+GetSeqAmRoutineByAMId(Oid amoid)
+{
+	HeapTuple		tuple;
+	regproc			amhandler;
+	Form_pg_am		amform;
+
+	/* Get handler function OID for the access method */
+	tuple = SearchSysCache1(AMOID, ObjectIdGetDatum(amoid));
+	if (!HeapTupleIsValid(tuple))
+		elog(ERROR, "cache lookup failed for access method %u",
+			 amoid);
+	amform = (Form_pg_am) GETSTRUCT(tuple);
+	amhandler = amform->amhandler;
+
+	/* Complain if handler OID is invalid */
+	if (!RegProcedureIsValid(amhandler))
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("sequence access method \"%s\" does not have a handler",
+						NameStr(amform->amname))));
+	ReleaseSysCache(tuple);
+
+	/* And finally, call the handler function. */
+	return GetSeqAmRoutine(amhandler);
+}
+
+/*
+ * GetSeqAmRoutineForRelation - look up the handler of the sequence access
+ * method for the given sequence Relation.
+ */
+SeqAmRoutine *
+GetSeqAmRoutineForRelation(Relation relation)
+{
+	SeqAmRoutine *seqam;
+	SeqAmRoutine *cseqam;
+
+	if (relation->rd_seqamroutine == NULL)
+	{
+		if (!OidIsValid(relation->rd_rel->relam))
+		{
+			char *relname = quote_qualified_identifier(get_namespace_name(RelationGetNamespace(relation)),
+													   RelationGetRelationName(relation));
+			elog(ERROR, "relation %s isn't sequence", relname);
+		}
+
+		seqam = GetSeqAmRoutineByAMId(relation->rd_rel->relam);
+		/* Save the data for later reuse in CacheMemoryContext */
+		cseqam = (SeqAmRoutine *) MemoryContextAlloc(CacheMemoryContext,
+												   sizeof(SeqAmRoutine));
+		memcpy(cseqam, seqam, sizeof(SeqAmRoutine));
+		relation->rd_seqamroutine = cseqam;
+	}
+
+	return relation->rd_seqamroutine;
+}
+
+/*
+ * ValidateSeqAmRoutine - to sanity check for the SeqAmRoutine returned by a
+ * handler.
+ *
+ * At the moment we only check that the StateTypeOid is valid type oid and that
+ * the type it points to is fixed width and will fit into the sequence page.
+ */
+void
+ValidateSeqAmRoutine(SeqAmRoutine *routine)
+{
+#define MAX_SEQAM_STATE_LEN \
+	MaxHeapTupleSize - MinHeapTupleSize - MAXALIGN(sizeof(FormData_pg_sequence))
+
+	Oid	stattypeoid = routine->StateTypeOid;
+
+	if (!get_typisdefined(stattypeoid))
+		ereport(ERROR,
+				(errmsg("type with OID %u does not exist",
+						stattypeoid)));
+
+	if (TypeIsToastable(stattypeoid))
+		ereport(ERROR,
+				(errcode(ERRCODE_DATATYPE_MISMATCH),
+				 errmsg("sequence access method state data type \"%s\" must not be toastable",
+						format_type_be(stattypeoid))));
+
+	if (get_typlen(stattypeoid) >= MAX_SEQAM_STATE_LEN)
+		ereport(ERROR,
+				(errcode(ERRCODE_DATATYPE_MISMATCH),
+				 errmsg("sequence access method state data type \"%s\" exceeds maximum allowed length (%lu)",
+						format_type_be(stattypeoid), MAX_SEQAM_STATE_LEN)));
+
+}
diff --git a/src/backend/access/sequence/seqlocal.c b/src/backend/access/sequence/seqlocal.c
new file mode 100644
index 0000000..03ac01f
--- /dev/null
+++ b/src/backend/access/sequence/seqlocal.c
@@ -0,0 +1,414 @@
+/*-------------------------------------------------------------------------
+ *
+ * seqlocal.c
+ *	  Local sequence access manager
+ *
+ * Portions Copyright (c) 1996-2015, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *        src/backend/access/sequence/seqlocal.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/htup_details.h"
+#include "access/reloptions.h"
+#include "access/seqamapi.h"
+#include "access/xact.h"
+#include "catalog/pg_type.h"
+#include "commands/defrem.h"
+#include "funcapi.h"
+#include "miscadmin.h"
+#include "utils/builtins.h"
+#include "utils/int8.h"
+#include "utils/rel.h"
+#include "utils/typcache.h"
+
+typedef struct LocalSequence
+{
+	FormData_pg_sequence	seq;
+	LocalSequenceState		state;
+} LocalSequence;
+
+/*
+ * We don't want to log each fetching of a value from a sequence,
+ * so we pre-log a few fetches in advance. In the event of
+ * crash we can lose (skip over) as many values as we pre-logged.
+ */
+#define SEQ_LOG_VALS	32
+
+static bytea *seqam_local_reloptions(Datum reloptions, bool validate);
+static Datum seqam_local_init(Relation seqrel, Form_pg_sequence seq,
+							  int64 restart_value, bool restart_requested,
+							  bool is_init);
+static int64 seqam_local_alloc(Relation seqrel, SequenceHandle *seqh,
+							   int64 nrequested, int64 *last);
+static void seqam_local_setval(Relation seqrel, SequenceHandle *seqh,
+							   int64 new_value);
+static Datum seqam_local_get_state(Relation seqrel, SequenceHandle *seqh);
+static void seqam_local_set_state(Relation seqrel, SequenceHandle *seqh,
+								  Datum amstate);
+
+static char *
+seqam_local_state_get_part(StringInfo buf, char *ptr, bool *found)
+{
+	*found = false;
+
+	resetStringInfo(buf);
+
+	while (*ptr != ',' && *ptr != ')')
+	{
+		char		ch = *ptr++;
+
+		if (ch == '\0')
+		{
+			*found = false;
+			return ptr;
+		}
+
+		appendStringInfoChar(buf, ch);
+
+		if (!*found)
+			*found = true;
+	}
+
+	return ptr;
+}
+
+Datum
+seqam_local_state_in(PG_FUNCTION_ARGS)
+{
+	char	   *state_str = PG_GETARG_CSTRING(0);
+	char	   *ptr;
+	Datum		d;
+	bool		found;
+	StringInfoData		buf;
+	LocalSequenceState *state = palloc(sizeof(LocalSequenceState));
+
+	ptr = state_str;
+	while (*ptr && isspace((unsigned char) *ptr))
+		ptr++;
+
+	if (*ptr != '(')
+		goto malformed;
+	ptr++;
+
+	initStringInfo(&buf);
+
+	/* last_value is required */
+	ptr = seqam_local_state_get_part(&buf, ptr, &found);
+	if (!found)
+		goto malformed;
+	d = DirectFunctionCall1(int8in, CStringGetDatum(buf.data));
+	state->last_value = DatumGetInt64(d);
+	if (*ptr == ',')
+		ptr++;
+
+	/* is_called is optional */
+	ptr = seqam_local_state_get_part(&buf, ptr, &found);
+	if (found)
+	{
+		d = DirectFunctionCall1(boolin, CStringGetDatum(buf.data));
+		state->is_called = DatumGetBool(d);
+		if (*ptr == ',')
+			ptr++;
+	}
+	else
+		state->is_called = true;
+
+	/* log_cnt is optional */
+	ptr = seqam_local_state_get_part(&buf, ptr, &found);
+	if (found)
+	{
+		d = DirectFunctionCall1(int4in, CStringGetDatum(buf.data));
+		state->log_cnt = DatumGetInt32(d);
+		if (*ptr == ',')
+			ptr++;
+	}
+	else
+		state->log_cnt = 0;
+
+	if (*ptr != ')' || *(++ptr) != '\0')
+		goto malformed;
+
+	PG_RETURN_POINTER(state);
+
+malformed:
+	ereport(ERROR,
+			(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
+			 errmsg("malformed seqam_local_state literal: \"%s\"",
+					state_str)));
+}
+
+Datum
+seqam_local_state_out(PG_FUNCTION_ARGS)
+{
+	LocalSequenceState *state = (LocalSequenceState *) PG_GETARG_POINTER(0);
+	StringInfoData		buf;
+
+	initStringInfo(&buf);
+
+	appendStringInfo(&buf, "("INT64_FORMAT",%s,%d)",
+					 state->last_value, state->is_called ? "t" : "f",
+					 state->log_cnt);
+
+	PG_RETURN_CSTRING(buf.data);
+}
+
+/*
+ * Handler function for the local sequence access method.
+ */
+Datum
+seqam_local_handler(PG_FUNCTION_ARGS)
+{
+	SeqAmRoutine *seqam = makeNode(SeqAmRoutine);
+
+	seqam->StateTypeOid = SEQAMLOCALSTATEOID;
+	seqam->amoptions = seqam_local_reloptions;
+	seqam->Init = seqam_local_init;
+	seqam->Alloc = seqam_local_alloc;
+	seqam->Setval = seqam_local_setval;
+	seqam->GetState = seqam_local_get_state;
+	seqam->SetState = seqam_local_set_state;
+
+	PG_RETURN_POINTER(seqam);
+}
+
+/*
+ * seqam_local_reloptions()
+ *
+ * Parse and verify the reloptions of a local sequence.
+ */
+static bytea *
+seqam_local_reloptions(Datum reloptions, bool validate)
+{
+	if (validate && PointerIsValid(DatumGetPointer(reloptions)))
+		ereport(ERROR,
+				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+				 errmsg("local sequence does not accept any storage parameters")));
+
+	return NULL;
+}
+
+/*
+ * seqam_local_init()
+ *
+ * Initialize local sequence
+ */
+static Datum
+seqam_local_init(Relation seqrel, Form_pg_sequence seq, int64 restart_value,
+				 bool restart_requested, bool is_init)
+{
+	LocalSequenceState	   *seqstate;
+
+	if (is_init)
+		seqstate = palloc0(sizeof(LocalSequenceState));
+	else
+		seqstate = &((LocalSequence *) seq)->state;
+
+	/*
+	 * If this is a new sequence or RESTART was provided in ALTER we should
+	 * reset our state to that new starting point.
+	 */
+	if (is_init || restart_requested)
+	{
+		seqstate->last_value = restart_value;
+		seqstate->is_called = false;
+	}
+
+	seqstate->log_cnt = 0;
+
+	return PointerGetDatum(seqstate);
+}
+
+/*
+ * seqam_local_alloc()
+ *
+ * Allocate a new range of values for a local sequence.
+ */
+static int64
+seqam_local_alloc(Relation seqrel, SequenceHandle *seqh, int64 nrequested,
+				  int64 *last)
+{
+	int64		incby,
+				maxv,
+				minv,
+				log,
+				fetch,
+				result,
+				next,
+				rescnt = 0;
+	bool		is_cycled,
+				is_called,
+				logit = false;
+	Form_pg_sequence	seq;
+	LocalSequenceState *localseq;
+
+	seq = sequence_read_options(seqh);
+	localseq = &((LocalSequence *) seq)->state;
+
+	next = result = localseq->last_value;
+	incby = seq->increment_by;
+	maxv = seq->max_value;
+	minv = seq->min_value;
+	is_cycled = seq->is_cycled;
+	fetch = nrequested;
+	log = localseq->log_cnt;
+	is_called = localseq->is_called;
+
+	/* We are returning last_value if not is_called so fetch one less value. */
+	if (!is_called)
+	{
+		nrequested--;
+		fetch--;
+	}
+
+	/*
+	 * Decide whether we should emit a WAL log record.  If so, force up the
+	 * fetch count to grab SEQ_LOG_VALS more values than we actually need to
+	 * cache.  (These will then be usable without logging.)
+	 *
+	 * If this is the first nextval after a checkpoint, we must force a new
+	 * WAL record to be written anyway, else replay starting from the
+	 * checkpoint would fail to advance the sequence past the logged values.
+	 * In this case we may as well fetch extra values.
+	 */
+	if (log < fetch || !is_called)
+	{
+		/* Forced log to satisfy local demand for values. */
+		fetch = log = fetch + SEQ_LOG_VALS;
+		logit = true;
+	}
+	else if (sequence_needs_wal(seqh))
+	{
+		fetch = log = fetch + SEQ_LOG_VALS;
+		logit = true;
+	}
+
+	/* Fetch new result value if is_called. */
+	if (is_called)
+	{
+		rescnt += sequence_increment(seqrel, &next, 1, minv, maxv, incby,
+									 is_cycled, true);
+		result = next;
+	}
+
+	/* Fetch as many values as was requested by backend. */
+	if (rescnt < nrequested)
+		rescnt += sequence_increment(seqrel, &next, nrequested - rescnt, minv,
+									 maxv, incby, is_cycled, false);
+
+	/* Last value available for calling backend. */
+	*last = next;
+	/* Values we made available to calling backend can't be counted as cached. */
+	log -= rescnt;
+
+	/* We might need to fetch even more values for our own caching. */
+	if (rescnt < fetch)
+		rescnt += sequence_increment(seqrel, &next, fetch - rescnt, minv,
+									 maxv, incby, is_cycled, false);
+
+	fetch -= rescnt;
+	log -= fetch;				/* adjust for any unfetched numbers */
+	Assert(log >= 0);
+
+	/*
+	 * Log our cached data.
+	 */
+	localseq->last_value = *last;
+	localseq->log_cnt = log;
+	localseq->is_called = true;
+
+	sequence_start_update(seqh, logit);
+
+	if (logit)
+	{
+		localseq->last_value = next;
+		localseq->log_cnt = 0;
+		localseq->is_called = true;
+
+		sequence_save_state(seqh, PointerGetDatum(localseq), true);
+	}
+
+	localseq->last_value = *last;
+	localseq->log_cnt = log;
+	localseq->is_called = true;
+
+	sequence_save_state(seqh, PointerGetDatum(localseq), false);
+
+	sequence_finish_update(seqh);
+
+	return result;
+}
+
+/*
+ * seqam_local_setval()
+ *
+ * Set value of a local sequence
+ */
+static void
+seqam_local_setval(Relation seqrel, SequenceHandle *seqh, int64 new_value)
+{
+	Datum				amstate;
+	LocalSequenceState *localseq;
+
+	amstate = sequence_read_state(seqh);
+	localseq = (LocalSequenceState *) DatumGetPointer(amstate);
+
+	localseq->last_value = new_value;		/* last fetched number */
+	localseq->is_called = true;
+	localseq->log_cnt = 0;			/* how much is logged */
+
+	sequence_start_update(seqh, true);
+	sequence_save_state(seqh, PointerGetDatum(localseq), true);
+	sequence_finish_update(seqh);
+
+	sequence_release_tuple(seqh);
+}
+
+/*
+ * seqam_local_get_state()
+ *
+ * Dump state of a local sequence (for pg_dump)
+ */
+static Datum
+seqam_local_get_state(Relation seqrel, SequenceHandle *seqh)
+{
+	Datum				amstate;
+	LocalSequenceState *localseq = palloc(sizeof(LocalSequenceState));
+
+	amstate = sequence_read_state(seqh);
+	memcpy(localseq, DatumGetPointer(amstate), sizeof(LocalSequenceState));
+	sequence_release_tuple(seqh);
+
+	return PointerGetDatum(localseq);
+}
+
+/*
+ * seqam_local_set_state()
+ *
+ * Restore previously dumped state of local sequence (used by pg_dump)
+*/
+static void
+seqam_local_set_state(Relation seqrel, SequenceHandle *seqh,
+					  Datum amstate)
+{
+	Form_pg_sequence	seq;
+	LocalSequenceState *localseq;
+
+	seq = sequence_read_options(seqh);
+	localseq = (LocalSequenceState *) DatumGetPointer(amstate);
+
+	sequence_check_range(localseq->last_value, seq->min_value, seq->max_value,
+						 "last_value");
+
+	sequence_start_update(seqh, true);
+	sequence_save_state(seqh, amstate, true);
+	sequence_finish_update(seqh);
+
+	sequence_release_tuple(seqh);
+}
diff --git a/src/backend/bootstrap/bootparse.y b/src/backend/bootstrap/bootparse.y
index 41d2fd4..e684f60 100644
--- a/src/backend/bootstrap/bootparse.y
+++ b/src/backend/bootstrap/bootparse.y
@@ -251,6 +251,7 @@ Boot_CreateStmt:
 													  false,
 													  true,
 													  false,
+													  InvalidOid,
 													  NULL);
 						elog(DEBUG4, "relation created with OID %u", id);
 					}
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index e997b57..b7cd40a 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -41,6 +41,7 @@
 #include "catalog/heap.h"
 #include "catalog/index.h"
 #include "catalog/objectaccess.h"
+#include "catalog/pg_am.h"
 #include "catalog/pg_attrdef.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_constraint.h"
@@ -88,6 +89,7 @@ static void AddNewRelationTuple(Relation pg_class_desc,
 					Oid reloftype,
 					Oid relowner,
 					char relkind,
+					Oid relam,
 					Datum relacl,
 					Datum reloptions);
 static ObjectAddress AddNewRelationType(const char *typeName,
@@ -849,6 +851,7 @@ AddNewRelationTuple(Relation pg_class_desc,
 					Oid reloftype,
 					Oid relowner,
 					char relkind,
+					Oid relam,
 					Datum relacl,
 					Datum reloptions)
 {
@@ -922,6 +925,7 @@ AddNewRelationTuple(Relation pg_class_desc,
 	new_rel_reltup->relowner = relowner;
 	new_rel_reltup->reltype = new_type_oid;
 	new_rel_reltup->reloftype = reloftype;
+	new_rel_reltup->relam = relam;
 
 	new_rel_desc->rd_att->tdtypeid = new_type_oid;
 
@@ -1035,6 +1039,7 @@ heap_create_with_catalog(const char *relname,
 						 bool use_user_acl,
 						 bool allow_system_table_mods,
 						 bool is_internal,
+						 Oid relam,
 						 ObjectAddress *typaddress)
 {
 	Relation	pg_class_desc;
@@ -1263,6 +1268,7 @@ heap_create_with_catalog(const char *relname,
 						reloftypeid,
 						ownerid,
 						relkind,
+						relam,
 						PointerGetDatum(relacl),
 						reloptions);
 
@@ -1275,7 +1281,8 @@ heap_create_with_catalog(const char *relname,
 	/*
 	 * Make a dependency link to force the relation to be deleted if its
 	 * namespace is.  Also make a dependency link to its owner, as well as
-	 * dependencies for any roles mentioned in the default ACL.
+	 * dependencies for any roles mentioned in the default ACL. When relam
+	 * is specified, record dependency on the pg_am record.
 	 *
 	 * For composite types, these dependencies are tracked for the pg_type
 	 * entry, so we needn't record them here.  Likewise, TOAST tables don't
@@ -1330,6 +1337,14 @@ heap_create_with_catalog(const char *relname,
 								  0, NULL,
 								  nnewmembers, newmembers);
 		}
+
+		if (relkind == RELKIND_SEQUENCE)
+		{
+			referenced.classId = AccessMethodRelationId;
+			referenced.objectId = relam;
+			referenced.objectSubId = 0;
+			recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
+		}
 	}
 
 	/* Post creation hook for new relation */
diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index cb3ba85..b40f0c7 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -16,6 +16,7 @@
 #include "postgres.h"
 
 #include "access/htup_details.h"
+#include "access/seqamapi.h"
 #include "access/sysattr.h"
 #include "catalog/catalog.h"
 #include "catalog/indexing.h"
diff --git a/src/backend/catalog/toasting.c b/src/backend/catalog/toasting.c
index f40a005..40b5e91 100644
--- a/src/backend/catalog/toasting.c
+++ b/src/backend/catalog/toasting.c
@@ -291,6 +291,7 @@ create_toast_table(Relation rel, Oid toastOid, Oid toastIndexOid,
 										   false,
 										   true,
 										   true,
+										   InvalidOid,
 										   NULL);
 	Assert(toast_relid != InvalidOid);
 
diff --git a/src/backend/commands/amcmds.c b/src/backend/commands/amcmds.c
index 68ea5f3..1f2e0c4 100644
--- a/src/backend/commands/amcmds.c
+++ b/src/backend/commands/amcmds.c
@@ -15,6 +15,8 @@
 
 #include "access/heapam.h"
 #include "access/htup_details.h"
+#include "access/seqamapi.h"
+#include "access/xact.h"
 #include "catalog/dependency.h"
 #include "catalog/indexing.h"
 #include "catalog/pg_am.h"
@@ -29,7 +31,7 @@
 #include "utils/syscache.h"
 
 
-static Oid	lookup_index_am_handler_func(List *handler_name, char amtype);
+static Oid	lookup_am_handler_func(List *handler_name, char amtype);
 static const char *get_am_type_string(char amtype);
 
 
@@ -72,7 +74,7 @@ CreateAccessMethod(CreateAmStmt *stmt)
 	/*
 	 * Get the handler function oid, verifying the AM type while at it.
 	 */
-	amhandler = lookup_index_am_handler_func(stmt->handler_name, stmt->amtype);
+	amhandler = lookup_am_handler_func(stmt->handler_name, stmt->amtype);
 
 	/*
 	 * Insert tuple into pg_am.
@@ -187,6 +189,16 @@ get_index_am_oid(const char *amname, bool missing_ok)
 }
 
 /*
+ * get_seq_am_oid - given an access method name, look up its OID
+ *		and verify it corresponds to an sequence AM.
+ */
+Oid
+get_seq_am_oid(const char *amname, bool missing_ok)
+{
+	return get_am_type_oid(amname, AMTYPE_SEQUENCE, missing_ok);
+}
+
+/*
  * get_am_oid - given an access method name, look up its OID.
  * 		The type is not checked.
  */
@@ -226,6 +238,8 @@ get_am_type_string(char amtype)
 	{
 		case AMTYPE_INDEX:
 			return "INDEX";
+		case AMTYPE_SEQUENCE:
+			return "SEQUENCE";
 		default:
 			/* shouldn't happen */
 			elog(ERROR, "invalid access method type '%c'", amtype);
@@ -240,9 +254,10 @@ get_am_type_string(char amtype)
  * This function either return valid function Oid or throw an error.
  */
 static Oid
-lookup_index_am_handler_func(List *handler_name, char amtype)
+lookup_am_handler_func(List *handler_name, char amtype)
 {
 	Oid			handlerOid;
+	Oid			handler_type;
 	static const Oid funcargtypes[1] = {INTERNALOID};
 
 	if (handler_name == NIL)
@@ -257,16 +272,21 @@ lookup_index_am_handler_func(List *handler_name, char amtype)
 	switch (amtype)
 	{
 		case AMTYPE_INDEX:
-			if (get_func_rettype(handlerOid) != INDEX_AM_HANDLEROID)
-				ereport(ERROR,
-						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
-						 errmsg("function %s must return type \"%s\"",
-								NameListToString(handler_name),
-								"index_am_handler")));
+			handler_type = INDEX_AM_HANDLEROID;
+			break;
+		case AMTYPE_SEQUENCE:
+			handler_type = SEQ_AM_HANDLEROID;
 			break;
 		default:
 			elog(ERROR, "unrecognized access method type \"%c\"", amtype);
 	}
 
+	if (get_func_rettype(handlerOid) != handler_type)
+		ereport(ERROR,
+				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+				 errmsg("function %s must return type \"%s\"",
+						NameListToString(handler_name),
+						format_type_be(handler_type))));
+
 	return handlerOid;
 }
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index 5cb28cf..54a22da 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -680,6 +680,7 @@ make_new_heap(Oid OIDOldHeap, Oid NewTableSpace, char relpersistence,
 										  false,
 										  true,
 										  true,
+										  InvalidOid,
 										  NULL);
 	Assert(OIDNewHeap != InvalidOid);
 
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index cb7a145..ab7b7a3 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -385,7 +385,8 @@ intorel_startup(DestReceiver *self, int operation, TupleDesc typeinfo)
 	/*
 	 * Actually create the target table
 	 */
-	intoRelationAddr = DefineRelation(create, relkind, InvalidOid, NULL);
+	intoRelationAddr = DefineRelation(create, relkind, InvalidOid, InvalidOid,
+									  NULL);
 
 	/*
 	 * If necessary, create a TOAST table for the target table.  Note that
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index 13b04e6..92ae4db 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -536,7 +536,7 @@ DefineIndex(Oid relationId,
 	reloptions = transformRelOptions((Datum) 0, stmt->options,
 									 NULL, NULL, false, false);
 
-	(void) index_reloptions(amoptions, reloptions, true);
+	(void) am_reloptions(amoptions, reloptions, true);
 
 	/*
 	 * Prepare arguments for index_create, primarily an IndexInfo structure.
